var $ = function(id){return document.getElementById(id);}
var center = [0.5,0];
var zoom = 400;
var limit = 50;
var width = 400;
var height = 400;
var array2d = function(width,height,initial){
	var w = typeof width === "undefined" ? 1 : width;
	var h = typeof height === "undefined" ? w : height;
	var res = [];
	res.length = w;
	for(var i=0;i<h;i++ ){
		res[i] = [];
		for(var j=0;j<w;j++){
			res[i][j] = initial;
		}
	}
	return res;
}
var generate = function(){
	$("log").innerHTML = "preparing...";
	center = [parseFloat($("center-x").value),parseFloat($("center-y").value)];
	zoom = parseFloat($("zoom").value,10);
	limit = parseInt($("limit").value,10);
	var nw = [center[0]-width/(2*zoom),center[1]-height/(2*zoom)];
	$("range-x").value = nw[0] + ":" + (nw[0]+width/zoom);
	$("range-y").value = nw[1] + ":" + (nw[1]+height/zoom);
	var state = array2d(width,height,-1);
	var end = function(){
		var endNum = 0;
		return function(res,x,y){
			//console.log("end")
			state[y][x] = res;
			endNum++;
			if(endNum === width*height){
				$("log").innerHTML = "complete!!";
				draw(state);
			}else{
				if((endNum%(height*10))===0)$("log").innerHTML = (endNum/width/height*100) + "% done";
			}
		}
	}();
	var genZ = function(ix,iy){
		var x = ix/zoom + nw[0];
		var y = iy/zoom + nw[1];
		var _genZ = function _(n,zx,zy){
			if((n===limit) || (zx*zx + zy*zy > 4)){
				end(n,ix,iy);
			}else{
				var _zx = zx*zx - zy*zy + x;
				var _zy = 2*zx*zy + y;
				setTimeout(_,1,n+1,_zx,_zy);
			}
		}
		return function(){_genZ(0,0,0)};
	}
	for(var y=0;y<height;y++){
		for(var x=0;x<width;x++){
			setTimeout(genZ(x,y),1000);
		}
	}
}
var draw = function(state){
	var canvas = document.getElementById("c");
	var gdc = canvas.getContext("2d");
	canvas.width = width;
	canvas.height = height;
	var im = gdc.getImageData(0,0,width,height);
	var setIm = function(x,y,color){
		var w = im.width,h = im.height;
		var offset = 4*(y*w+x);
		im.data[offset] = color[0];
		im.data[offset+1] = color[1];
		im.data[offset+2] = color[2];
		im.data[offset+3] = color[3];
	}
	var color = function(level){
		var res =  [1,0.5,0.75].map(function(v){return level===limit ? 0 : v*255*level/limit});
		res.push(255);
		return res;
	}
	for(var y=0;y<height;y++){
		for(var x=0;x<width;x++){
			setIm(x,y,color(state[y][x]));
		}
	}
	gdc.putImageData(im,0,0);
}
